/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: ExactSubstringNameMatcher.java,v 3e7ea5dbefcb 2010/05/17 15:10:54 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.taxonomy;

import javax.annotation.Nonnull;
import java.util.Locale;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class ExactSubstringNameMatcher implements NameMatcher
  {
    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public boolean matches (final @Nonnull String string, 
                            final @Nonnull CharSequence match,
                            final @Nonnull Locale locale)
      {
        if (match.length() == 0)
          {
            return true;
          }

        final String lowerCaseString = string.toLowerCase(locale);
        final String lowerCaseMatch = match.toString().toLowerCase(locale);

        return Character.isUpperCase(match.charAt(0)) ? lowerCaseString.startsWith(lowerCaseMatch)
                                                      : lowerCaseString.contains(lowerCaseMatch);
      }
  }
